package com.example.acer.agendita_mysql_c;

import android.content.ContentValues;
import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import librerias.MiBaseDatos;
import librerias.Parametros;


public class NuevoUsuarioFragment extends Fragment implements View.OnClickListener, View.OnKeyListener {
    EditText txtUsuario, txtPassword, txtNombre, txtApellidos;
    Button btnGrabar, btnCancelar;
    Spinner spinnerTipoUsuario;
    String tipoUsuario="";
    MiBaseDatos baseDatos;
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_nuevo_usuario, container, false);
    }
    public void onStart(){
        super.onStart();
        //creamos el listado de usuarios que agregaremos al espiner
        final String[] strTiposUsuario = new String[]{
                "Tipo de Usuario..",
                "Administrador",
                "Limitado"};
        //inicializamos los objetos
        spinnerTipoUsuario = (Spinner)getView().findViewById(R.id.spnUsuarioNuevo);
        txtUsuario=(EditText)getView().findViewById(R.id.txtUsuarioNuevo);
        txtPassword=(EditText)getView().findViewById(R.id.txtPassNuevo);
        txtNombre=(EditText)getView().findViewById(R.id.txtNombreNuevo);
        txtApellidos=(EditText)getView().findViewById(R.id.txtApellidoNuevo);
        btnGrabar=(Button)getView().findViewById(R.id.btnGrabarNuevo);
        btnCancelar=(Button)getView().findViewById(R.id.btnCancelarNuevo);
        //creamos el adaptador para el espiner
        ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<String>(
                getContext(),R.layout.textview_para_spinner,strTiposUsuario );
        //agregamos la vista para elegir el tipo de letra del espiner
        spinnerArrayAdapter.setDropDownViewResource(R.layout.textview_para_spinner);
        //le agregamos al spinner el listado
        spinnerTipoUsuario.setAdapter(spinnerArrayAdapter);
        //agregamos el escuchador a spinner
        spinnerTipoUsuario.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                if(spinnerTipoUsuario.getSelectedItemPosition()==1) {
                    tipoUsuario = "Admin";
                }else if(spinnerTipoUsuario.getSelectedItemPosition()==2) {
                    tipoUsuario="Limitado";
                }
            }
            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {
            }
        });
        //agregamos los escuchadores a los botones
        btnCancelar.setOnClickListener(this);
        btnGrabar.setOnClickListener(this);
        txtUsuario.setOnKeyListener(this);
        txtPassword.setOnKeyListener(this);
        txtNombre.setOnKeyListener(this);

    }
    public void cancelar(){
        txtApellidos.setText("");
        txtPassword.setText("");
        txtNombre.setText("");
        txtUsuario.setText("");
        spinnerTipoUsuario.setSelection(0);
        tipoUsuario="";
    }
    public void grabarLocal(){
        String usuario=txtUsuario.getText().toString();
        String pass=txtPassword.getText().toString();
        String nombre=txtNombre.getText().toString();
        String apellidos=txtApellidos.getText().toString();
        if(usuario.equals("")||pass.equals("")||nombre.equals("")||apellidos.equals("")||tipoUsuario.equals("")){
            Toast.makeText(getContext(),"Favor de Llenar todos los Datos",Toast.LENGTH_LONG).show();
        }else{
            baseDatos=new MiBaseDatos(getContext());
            SQLiteDatabase sql=baseDatos.getWritableDatabase();
            ContentValues contenido=new ContentValues();
            contenido.put(Parametros.campo_nombre_usuario,usuario);
            contenido.put(Parametros.campo_password,pass);
            contenido.put(Parametros.campo_tipo,tipoUsuario);
            contenido.put(Parametros.campo_nombre_usuario,nombre);
            contenido.put(Parametros.campo_apellido_usuario,apellidos);
            sql.insertWithOnConflict(Parametros.tabla_usuarios,null,contenido,SQLiteDatabase.CONFLICT_NONE);
            sql.close();
            cancelar();
            Toast.makeText(getContext(),"Registro Almacenado",Toast.LENGTH_LONG).show();
        }
    }

    @Override
    public void onClick(View v) {
        if(v.getId()==R.id.btnGrabarNuevo){
                grabarLocal();
        }else  if(v.getId()==R.id.btnCancelarNuevo){
                cancelar();
        }
    }

    @Override
    public boolean onKey(View v, int keyCode, KeyEvent event) {
        if(v.getId()==R.id.txtUsuarioNuevo){
            if(event.getKeyCode()==66){
                txtPassword.requestFocus();
            }
        }else if(v.getId()==R.id.txtPassNuevo) {
            if(event.getKeyCode()==66){
                txtNombre.requestFocus();
            }
        }else if(v.getId()==R.id.txtNombreNuevo){
            if(event.getKeyCode()==66){
                txtApellidos.requestFocus();
            }
        }else if(v.getId()==R.id.txtApellidoNuevo){

        }
        return true;
    }
}
